#!/bin/bash
# gd_install.sh
# created and copyrighted: Thu 04 Dec 2014 02:14:02 PM EST
#
# author: Evsiz (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#


# consts
name=$1
lname=`echo $name | tr [:upper:] [:lower:]`
dom=$2
path=`echo $2".$lname" | tr . /`
bdir=$3/$1

# code
usage () {
	echo "
usage: gd_install.sh PackageName com.domain.more  builddir

  Where your domain is domain.com, more is optional, and builddir is
  the top directory already containing directory PackageName as
  prepped by pride, eclipse, or similar.  Replace any hyphens with
  underscores in domain for proper java package rules.

  WARNING: This script removes all content from
  builddir/PackageName/[res|src/com/domain/packagename|assets]

	"
	exit
}

if [ $# -ne 3 ]; then
	usage
fi

echo "
Installing "$name" to "$bdir"
Enter to continue. Ctrl-c to exit

  WARNING: This script removes all content from
  builddir/PackageName/[res|src/com/domain/packagename|assets]

"
read

cp AndroidManifest.xml $bdir

rm -r $bdir/assets
cp -r ./assets $bdir

rm -r $bdir/res/*
cp -r ./res/* $bdir/res/

rm -r $bdir/src/$path/*
cp -r ./src/* $bdir/src/$path/ 
mv $bdir/src/$path/BoilerPlate.java $bdir/src/$path/$name.java

sr $bdir BoilerPlate $name
sr $bdir BPpackage $dom.$lname
