package BPpackage;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.Gravity;
import android.view.View;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Exception;
import java.lang.IllegalAccessException;
import java.lang.IllegalArgumentException;
import java.lang.reflect.Field;
import java.lang.Runnable;
import java.lang.String;
import java.util.ArrayList;
import java.util.HashMap;
import BPpackage.PRAFileHandler;
import BPpackage.R;


public class Dialog extends Activity {

	public PRAFileHandler fhandler = new PRAFileHandler(this);
	public HashMap<String, String[]> dict;
    public Button next;
    public Button playPause;
    public Button prev;
    public Button restart;
    public Button begin;
    public CheckBox repeat;
    public RadioButton minusTen;
    public RadioButton minusTwenty;
    public RadioButton normal;
    public RadioGroup playSpeed;
    public TextView title;
    public WebView webview;

    public boolean paused = true;
    public boolean playing = false;
    public boolean wasPlaying = false;
    public boolean repeating = true;
    public float speed = 1.0f;
	public int currentTrack = 0;

    public ArrayList<Integer> tracks;
    public WavTrack mTrack = null;

	public String page = "<html> <head> <meta charset=\"utf-8\"> <title>Chu 01"+
		"</title> </head> <body bgcolor=#ffffeb text=#000>" +
		"<style type=text/css>h3,h4{color: #a30000}</style>";
	public String tizi = "jian";
	public String num = "";
	public int index = 0;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Intent origin = this.getIntent();
		tizi = origin.getStringExtra("TIZI");
		num = origin.getStringExtra("NUM");
		index = origin.getIntExtra("POS",0);
		dict = (HashMap<String, String[]>)origin.getSerializableExtra("DICT");

		// ui
        setContentView(R.layout.activity_dialog);
        findViews();
		title.setText("Chu "+num);
		playPause.setBackgroundResource(R.drawable.icon_av_play);
		restart.setBackgroundResource(R.drawable.icon_av_restart);

		// wv with notes
		webview.setScrollBarStyle(View.SCROLLBARS_INSIDE_OVERLAY);
		webview.getSettings().setBuiltInZoomControls(true);
		webview.getSettings().setSupportZoom(true);
		webview.loadUrl("file:///android_asset/chu_"+num+".html");

	}

	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		webview = (WebView) findViewById(R.id.webview);
		playPause = (Button) findViewById(R.id.playPause);
		playSpeed = (RadioGroup) findViewById(R.id.playSpeed);
		normal = (RadioButton) findViewById(R.id.normal);
		minusTen = (RadioButton) findViewById(R.id.minusTen);
		minusTwenty = (RadioButton) findViewById(R.id.minusTwenty);
		restart = (Button) findViewById(R.id.restart);
		begin = (Button) findViewById(R.id.begin);
	}

	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

	public void begin(View view){
		begin.setVisibility(View.GONE);
		playPause.setVisibility(View.VISIBLE);
		playSpeed.setVisibility(View.VISIBLE);
		restart.setVisibility(View.VISIBLE);

		toaster("Adjust zoom. Press play.", Toast.LENGTH_SHORT);

        tracks = new ArrayList<Integer>();
        Field[] fields = R.raw.class.getFields();
        try {
            tracks.add(fields[index].getInt(null));
        } catch (IllegalArgumentException e) {
        } catch (IllegalAccessException e) { }

		String[] db = fhandler.getAssetAsArray("chu_"+num+".txt");
		String[] tokens;
		String line;
		String[] tmp;
		String t;
		int zi = 0;
		if (tizi.matches("fan")){
			zi = 1;
		}
		for (String l : db){
			if (l.trim().matches("")){ break; }
			line = "";
			while (l.contains("  ")){
				l = l.replace("  ", " ");
			}
			tokens = l.split(" ");
			for (String s : tokens){
				if (s.contains(":")){
					line = "<p>"+tokens[0]+" ";
				} else if (s.contains(">")){
					line = s;
				} else {
					tmp = dict.get(s);
					if (tmp == null){ 
						t = " XX"+ s +"XX ";
					} else {
						t = tmp[zi];
					}
					line = line+t;
				}
			 }
			page = page + line;
		}
		page = page+"<h1>&nbsp;</h1>";
		webview.loadData(page, "text/html;charset=utf-8", "utf-8");		
	}

	public void trackEnded(){
		if (repeating){
			newTrack();
		} else {
			paused = true;
			playing = false;
			mTrack.pause();
			mTrack.finished();
			mTrack = null;
		}
	}

	public void restart(View view){
		if (!playing){ return; }
  		playPause.setBackgroundResource(R.drawable.icon_av_pause);
		paused = false;
   		newTrack();
		System.gc();
	}

	public void newTrack(){
		if ((playing) && (mTrack != null)){
			mTrack.pause();
			mTrack.finished();
		}
		mTrack = null;
		mTrack = new WavTrack(this, tracks.get(currentTrack), speed);
	}

    public void trackPlayPause(View view){
        paused = !paused;
        if ((paused) && (mTrack != null)){
    		playPause.setBackgroundResource(R.drawable.icon_av_play);
			try {
				mTrack.pause();
			} catch (Exception e) { }

        } else {
    		playPause.setBackgroundResource(R.drawable.icon_av_pause);
            if (!playing){
                playing = true;
                newTrack();
            } else {
				try {
					mTrack.play();
				} catch (Exception e) { }
            }
        }
    }

    public void onRadioButtonClicked(View view) {
        boolean checked = ((RadioButton) view).isChecked();
		if (mTrack == null){ 
			normal.toggle(); 
			toaster("Press play before setting speed.", Toast.LENGTH_SHORT);
			return; 
		}
        switch(view.getId()) {
            case R.id.normal:
                if (checked) {
                    speed = 1.0f;
				}
                break;
            case R.id.minusTen:
                if (checked){
                    speed = 0.92f;
				}
                break;
            case R.id.minusTwenty:
                if (checked){
                    speed = 0.85f;
				}
                break;
        }
		mTrack.changeSpeed(speed);
    }

    @Override
    protected void onPause() {
        super.onPause();
		if (!paused){
			wasPlaying = true;
			paused = true;
			playPause.setBackgroundResource(R.drawable.icon_av_play);
			if (mTrack != null) {
			    mTrack.pause();
			}
		}
   }

    @Override
    protected void onResume() {
        super.onPause();
		if ((mTrack != null) && wasPlaying) {
	   		wasPlaying = false;
			paused = false;
			playPause.setBackgroundResource(R.drawable.icon_av_pause);
		    mTrack.play();
		}
	}


	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			super.onBackPressed();
			return;
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}

}
