package BPpackage.flashcards;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import android.widget.Toast;
import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import BPpackage.EdgeEffectListView;
import BPpackage.PRAFileHandler;
import BPpackage.R;


public class LessonSelection extends ListActivity {
	
	public PRAFileHandler fhandler = new PRAFileHandler(this);
	public Map<String, String> dbs = new HashMap<String, String>();
	public int MODE;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		Intent origin = this.getIntent();
		MODE = origin.getIntExtra("MODE", 0);
		super.onCreate(savedInstanceState);
		final String[] list = buildList();
		setContentView(R.layout.activity_deck_selection);
		setListAdapter(new ArrayAdapter<String>(this,
				R.layout.pra_list_item, list));

		EdgeEffectListView listView = (EdgeEffectListView) getListView();
		listView.setTextFilterEnabled(true);

		listView.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				String result = ((TextView) view).getText().toString();
				String num = dbs.get(result);
				String card = null;
				List<String> alist = null;
				String[] selection = null;

				if (!result.startsWith("Last Test")){
					alist = new ArrayList<String>();
					String[] db = fhandler.getAssetAsArray("ruzhechu.db");
					for (String l : db){
						if (l.startsWith(num)){
							while (l.contains("\t\t")){
								l = l.replace("\t\t", "\t");
							}
							card = l.replaceFirst(num+"\t", "");
							while (card.startsWith("\t")){
								card = card.replaceFirst("\t", "");
							}
							alist.add(card);
						}
					}
					selection = new String[alist.size()];
					alist.toArray(selection);
				} else {
					selection = fhandler.getFileAsArray(num);
				}
				Intent intent = new Intent();
				intent.putExtra("SELECTION", selection);
				intent.putExtra("SET", num);
				setResult(RESULT_OK, intent);
				finish();
			}
		});
	}

	private String[] buildList() {
		List<String> alist = new ArrayList<String>();
		String[] files = fhandler.listAssets(".txt");
		String name = "";
		String num = "";
		alist = new ArrayList<String>();
		for (String f : files) {
			name = f.replace('_', ' ');
			name = name.replace(".txt", "");
			// TODO locale for next line
			name = Character.toUpperCase(name.charAt(0)) + name.substring(1);
			alist.add(name);
			num = name.split(" ")[1];
			dbs.put(name, num);
		}

		Collections.sort(alist);

		if (MODE == 0){
			File internal = getFilesDir();
			File[] ifiles = internal.listFiles();
			String fname = null;
			String[] tokens = null;
			for (File inFile : ifiles) {
				fname = inFile.toString();
				tokens	= fname.split("/");
				fname = tokens[tokens.length - 1];
				if (fname.startsWith("last_test")){
					name = fname.replace('_', ' ');
					name = name.replace(".txt", "");
					name = name.replace("last test", "Last Test:");
					alist.add(name);
					dbs.put(name, fname);
				}
			}
		}

		
		String[] list = new String[alist.size()];
		alist.toArray(list);
		return list;
	}

	@Override
	public void onBackPressed() {
		Intent intent = new Intent();
		setResult(RESULT_CANCELED, intent);
		finish();
	}

    @Override
    protected void onResume() {
        super.onResume();
    }


	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

}
